//! Local state change error
use super::*;
use std::{
    error,
    fmt,
};

/// Local state updating errors
#[derive(Debug)]
#[non_exhaustive]
pub enum Error {
    BroadcastUpdate,
    Unknown,
}
impl error::Error for Error{}
impl fmt::Display for Error
{
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result
    {
	match self {
	    Self::BroadcastUpdate => write!(f, "failed to broadcast state body update"),
	    _ => write!(f, "unknown error"),
	}
    }
}

